## librime 1.6.1+dfsg1

=== CMakeLists.txt ===
set(CMAKE_USER_MAKE_RULES_OVERRIDE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/c_flag_overrides.cmake)
set(CMAKE_USER_MAKE_RULES_OVERRIDE_CXX ${CMAKE_CURRENT_SOURCE_DIR}/cmake/cxx_flag_overrides.cmake)

project(rime)
cmake_minimum_required(VERSION 3.0.2)

set(rime_version 1.6.1)
set(rime_soversion 1)

add_definitions(-DRIME_VERSION="${rime_version}")

include(GNUInstallDirs)

option(BUILD_SHARED_LIBS "Build Rime as shared library" ON)
option(BUILD_MERGED_PLUGINS "Merge plugins into one Rime library" ON)
option(BUILD_STATIC "Build with dependencies as static libraries" OFF)
option(BUILD_DATA "Build data for Rime" OFF)
option(BUILD_SAMPLE "Build sample Rime plugin" OFF)
option(BUILD_TEST "Build and run tests" ON)
option(BUILD_SEPARATE_LIBS "Build separate rime-* libraries" OFF)
option(ENABLE_LOGGING "Enable logging with google-glog library" ON)
option(BOOST_USE_CXX11 "Boost has been built with C++11 support" OFF)
option(BOOST_USE_SIGNALS2 "Boost use signals2 instead of signals" ON)
option(ENABLE_ASAN "Enable Address Sanitizer (Unix Only)" OFF)

set(rime_data_dir "/share/rime-data" CACHE STRING "Target directory for Rime data")

if(WIN32)
  set(ext ".exe")
endif(WIN32)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "${PROJECT_SOURCE_DIR}/thirdparty")

if (ENABLE_ASAN)
  set(asan_cflags "-fsanitize=address -fno-omit-frame-pointer")
  set(asan_lflags "-fsanitize=address -lasan")
  set(CMAKE_C_FLAGS "${asan_cflags} ${CMAKE_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${asan_cflags} ${CMAKE_CXX_FLAGS}")
  set(CMAKE_EXE_LINKER_FLAGS "${asan_lflags} ${CMAKE_EXE_LINKER_FLAGS}")
  set(CMAKE_SHARED_LINKER_FLAGS "${asan_lflags} ${CMAKE_SHARED_LINKER_FLAGS}")
endif()

set(Boost_USE_STATIC_LIBS ${BUILD_STATIC})
set(Gflags_STATIC ${BUILD_STATIC})
set(Glog_STATIC ${BUILD_STATIC})
set(LevelDb_STATIC ${BUILD_STATIC})
set(Marisa_STATIC ${BUILD_STATIC})
set(Opencc_STATIC ${BUILD_STATIC})
set(YamlCpp_STATIC ${BUILD_STATIC})

set(Boost_USE_MULTITHREADED ON)
if(MSVC)
  set(Boost_USE_STATIC_RUNTIME ON)
endif()

if(NOT BOOST_USE_CXX11)
  add_definitions("-DBOOST_NO_CXX11_SCOPED_ENUMS")
endif()

set(BOOST_COMPONENTS filesystem regex system)

if(BOOST_USE_SIGNALS2)
  add_definitions("-DBOOST_SIGNALS2")
else()
  set(BOOST_COMPONENTS ${BOOST_COMPONENTS} signals)
endif()

find_package(Boost 1.46.0 REQUIRED COMPONENTS ${BOOST_COMPONENTS})
if(Boost_FOUND)
  include_directories(${Boost_INCLUDE_DIRS})
  link_directories(${Boost_LIBRARY_DIRS})
endif()

find_package(CapnProto REQUIRED)

if(ENABLE_LOGGING)

  find_package(Gflags)
  if(Gflags_FOUND)
    include_directories(${Gflags_INCLUDE_PATH})
  endif()

  find_package(Glog REQUIRED)
  if(Glog_FOUND)
    include_directories(${Glog_INCLUDE_PATH})
  endif()
  if(Glog_STATIC)
    add_definitions(-DGOOGLE_GLOG_DLL_DECL=)
  endif()

  add_definitions(-DRIME_ENABLE_LOGGING)

endif()

find_package(Threads)

if(BUILD_TEST)
  find_package(GTest REQUIRED)
  if(GTEST_FOUND)
    enable_testing()
    include_directories(${GTEST_INCLUDE_DIRS})
  endif()
endif()

find_package(YamlCpp REQUIRED)
if(YamlCpp_FOUND)
  include_directories(${YamlCpp_INCLUDE_PATH})
endif()

find_package(LevelDb REQUIRED)
if(LevelDb_FOUND)
    include_directories(${LevelDb_INCLUDE_PATH})
endif()

find_package(Marisa REQUIRED)
if(Marisa_FOUND)
  include_directories(${Marisa_INCLUDE_PATH})
endif()

find_package(Opencc REQUIRED)
if(Opencc_FOUND)
include_directories(${Opencc_INCLUDE_PATH})
endif()
if(Opencc_STATIC)
  add_definitions(-DOpencc_BUILT_AS_STATIC)
endif()

find_path(X11Keysym X11/keysym.h)
if(X11Keysym)
  message(STATUS "Found X11/keysym.h at ${X11Keysym}")
  include_directories(${X11Keysym})
else()
  message(WARNING "X11/keysym.h not found.")
endif()

include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/thirdparty/include)
link_directories(${PROJECT_SOURCE_DIR}/thirdparty/lib)

if(MSVC)
  # https://stackoverflow.com/a/31264946
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Zi")
  set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /DEBUG /OPT:REF /OPT:ICF")
  if(MSVC10)
    # stdint.h is missing from VS2010
    include_directories(${PROJECT_SOURCE_DIR}/thirdparty/include/msvc)
  endif()
  # Force Boost.Uuid to use wincrypt as random provider instead of bcrypt for Windows XP compatibility
  add_definitions("/wd4244 /wd4996 /DBOOST_UUID_RANDOM_PROVIDER_FORCE_WINCRYPT")
endif()

if(UNIX)
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
endif()

if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})
endif()

if(NOT DEFINED BIN_INSTALL_DIR)
    set(BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR})
endif()

# uninstall target
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
add_custom_target(uninstall
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux|FreeBSD|DragonFly|GNU")
  set(prefix "${CMAKE_INSTALL_PREFIX}")
  set(exec_prefix "${CMAKE_INSTALL_PREFIX}")
  set(bindir "${exec_prefix}/${BIN_INSTALL_DIR}")
  set(libdir "${exec_prefix}/${LIB_INSTALL_DIR}")
  set(pkgdatadir "${prefix}${rime_data_dir}")
  set(includedir "${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
  configure_file(
      ${PROJECT_SOURCE_DIR}/rime.pc.in
      ${PROJECT_BINARY_DIR}/rime.pc
      @ONLY)
  install(FILES ${PROJECT_BINARY_DIR}/rime.pc
    DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
endif()

install(FILES cmake/RimeConfig.cmake DESTINATION share/cmake/rime)

file(GLOB rime_public_header_files ${PROJECT_SOURCE_DIR}/src/*.h)
install(FILES ${rime_public_header_files} DESTINATION include)

if(BUILD_DATA)
  file(GLOB rime_preset_data_files ${PROJECT_SOURCE_DIR}/data/preset/*.yaml)
  install(FILES ${rime_preset_data_files}
    DESTINATION ${CMAKE_INSTALL_PREFIX}${rime_data_dir})
endif()

if(BUILD_SHARED_LIBS)
  add_definitions(-DRIME_BUILD_SHARED_LIBS)
  set(rime_library rime)
  if(BUILD_SEPARATE_LIBS)
    set(rime_dict_library rime-dict)
    set(rime_gears_library rime-gears)
    set(rime_levers_library rime-levers)
  endif()
else()
  set(rime_library rime-static)
endif()

add_subdirectory(proto)
include_directories(${RIME_PROTO_INCLUDE_DIR})

add_subdirectory(plugins)
message(STATUS "rime_plugins_libs: ${rime_plugins_deps}")
message(STATUS "rime_plugins_modules: ${rime_plugins_modules}")
set(list "")
foreach(mod ${rime_plugins_modules})
  set(list "${list},Q(${mod})")
endforeach()
add_definitions(-DRIME_EXTRA_MODULES=${list})
if(BUILD_SHARED_LIBS AND BUILD_SEPARATE_LIBS AND rime_plugins_objs)
  set(rime_plugins_library rime-plugins)
endif()

add_subdirectory(src)

if(BUILD_SHARED_LIBS)
  add_subdirectory(tools)

  if(BUILD_TEST)
    add_subdirectory(test)
  endif()

  if (BUILD_SAMPLE)
    add_subdirectory(sample)
  endif()
endif()

=== Makefile ===
RIME_ROOT = $(CURDIR)

sharedir = $(DESTDIR)/usr/share
bindir = $(DESTDIR)/usr/bin

build = build
librime-static: build = build-static
debug install-debug uninstall-debug test-debug: build = debug

.PHONY: all thirdparty xcode clean \
librime librime-static install-librime uninstall-librime \
release debug test install uninstall install-debug uninstall-debug

all: release

thirdparty:
	make -f thirdparty.mk

thirdparty/%:
	make -f thirdparty.mk $(@:thirdparty/%=%)

xcode:
	make -f xcode.mk

xcode/%:
	make -f xcode.mk $(@:xcode/%=%)

clean:
	rm -Rf build build-static debug

librime: release
install-librime: install
uninstall-librime: uninstall

librime-static:
	cmake . -B$(build) \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_BUILD_TYPE=Release \
	-DBUILD_STATIC=ON \
	-DBUILD_SHARED_LIBS=OFF
	cmake --build $(build)

release:
	cmake . -B$(build) \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_BUILD_TYPE=Release \
	-DBUILD_MERGED_PLUGINS=OFF
	cmake --build $(build)

merged-plugins:
	cmake . -B$(build) \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_BUILD_TYPE=Release \
	-DBUILD_MERGED_PLUGINS=ON
	cmake --build $(build)

debug:
	cmake . -B$(build) \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_BUILD_TYPE=Debug
	cmake --build $(build)

install:
	cmake --build $(build) --target install

install-debug:
	cmake --build $(build) --target install

uninstall:
	cmake --build $(build) --target uninstall

uninstall-debug:
	cmake --build $(build) --target uninstall

test: release
	(cd $(build)/test; ./rime_test)

test-debug: debug
	(cd $(build)/test; ./rime_test)

=== plugins/CMakeLists.txt ===
set(RIME_SOURCE_DIR ${PROJECT_SOURCE_DIR})
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

# work around CMake build issues on macOS
aux_source_directory(. rime_plugins_src)

unset(plugins_objs)
unset(plugins_deps)
unset(plugins_modules)

if(DEFINED ENV{RIME_PLUGINS})
  set(plugins $ENV{RIME_PLUGINS})
  message(STATUS "Prescribed plugins: ${plugins}")
  if(NOT "${plugins}" STREQUAL "")
    string(REGEX REPLACE "[^ ]*/(librime-)?" "" plugins ${plugins})
    string(REPLACE " " ";" plugins ${plugins})
  endif()
else()
  file(GLOB plugin_files "*")
  foreach(file ${plugin_files})
    if(IS_DIRECTORY ${file})
      message(STATUS "Found plugin: ${file}")
      set(plugins ${plugins} ${file})
    endif()
  endforeach(file)
endif()

foreach(plugin ${plugins})
  unset(plugin_name)
  unset(plugin_objs)
  unset(plugin_deps)
  unset(plugin_modules)
  add_subdirectory(${plugin})
  if(BUILD_MERGED_PLUGINS)
    set(plugins_objs ${plugins_objs} ${plugin_objs})
    list(REMOVE_ITEM plugin_deps ${rime_library})
    set(plugins_deps ${plugins_deps} ${plugin_deps})
    set(plugins_modules ${plugins_modules} ${plugin_modules})
  else()
    message(STATUS "Plugin ${plugin_name} provides modules: ${plugin_modules}")
    add_library(${plugin_name} ${rime_plugins_src} ${plugin_objs})
    target_link_libraries(${plugin_name} ${plugin_deps})
    if(XCODE_VERSION)
      set_target_properties(${plugin_name} PROPERTIES INSTALL_NAME_DIR "@rpath")
    endif(XCODE_VERSION)
    install(TARGETS ${plugin_name} DESTINATION ${LIB_INSTALL_DIR})
  endif()
endforeach(plugin)

set(rime_plugins_objs ${plugins_objs} PARENT_SCOPE)
set(rime_plugins_deps ${plugins_deps} PARENT_SCOPE)
set(rime_plugins_modules ${plugins_modules} PARENT_SCOPE)

=== proto/CMakeLists.txt ===
# search path for capnp schemata: *.capnp
set(RIME_PROTO_SCHEMA_DIR ${CMAKE_CURRENT_SOURCE_DIR} PARENT_SCOPE)
# search path for generated capnp binding headers: *.capnp.h
set(RIME_PROTO_INCLUDE_DIR ${CMAKE_CURRENT_BINARY_DIR} PARENT_SCOPE)

capnp_generate_cpp(
  CAPNP_SRCS
  CAPNP_HDRS
  rime_proto.capnp
)
message(STATUS "compiled capnproto schemata (sources): ${CAPNP_SRCS}")
message(STATUS "compiled capnproto schemata (headers): ${CAPNP_HDRS}")

add_library(rime-proto-objs OBJECT ${CAPNP_SRCS})
target_include_directories(rime-proto-objs PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
if(BUILD_SHARED_LIBS)
set_target_properties(rime-proto-objs
  PROPERTIES
  POSITION_INDEPENDENT_CODE ON)
endif()

set(rime_proto_objs $<TARGET_OBJECTS:rime-proto-objs> PARENT_SCOPE)

=== sample/CMakeLists.txt ===
project(rime-sample)
cmake_minimum_required(VERSION 2.8)

set(SAMPLE_VERSION 1.0.0)
set(SAMPLE_SOVERSION 1)

aux_source_directory(src sample_src)

set(sample_library rime-sample)
set(sample_deps ${rime_library})
set(sample_modules "sample")

if(BUILD_SAMPLE)
  # to build the sample plugin, console app and tests, set BUILD_SAMPLE=ON
  set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

  message(STATUS "${sample_library} provides modules: ${sample_modules}")
  add_library(${sample_library} ${sample_src})
  target_link_libraries(${sample_library} ${sample_deps})
  set_target_properties(${sample_library}
    PROPERTIES
    VERSION ${SAMPLE_VERSION}
    SOVERSION ${SAMPLE_SOVERSION})
  if(XCODE_VERSION)
    set_target_properties(${sample_library}
      PROPERTIES
      INSTALL_NAME_DIR "@rpath")
  endif(XCODE_VERSION)
  install(TARGETS ${sample_library} DESTINATION ${LIB_INSTALL_DIR})

  add_subdirectory(tools)
  if(BUILD_TEST)
    add_subdirectory(test)
  endif()
else()
  # to build as a standard Rime plugin, link or copy the directory to plugins/
  add_library(rime-sample-objs OBJECT ${sample_src})
  if(BUILD_SHARED_LIBS)
    set_target_properties(rime-sample-objs
      PROPERTIES
      POSITION_INDEPENDENT_CODE ON)
  endif()

  set(plugin_name ${sample_library} PARENT_SCOPE)
  set(plugin_objs $<TARGET_OBJECTS:rime-sample-objs> PARENT_SCOPE)
  set(plugin_deps ${sample_deps} PARENT_SCOPE)
  set(plugin_modules ${sample_modules} PARENT_SCOPE)
endif()

=== src/CMakeLists.txt ===
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

aux_source_directory(. rime_api_src)
aux_source_directory(rime rime_base_src)
aux_source_directory(rime/algo rime_algo_src)
aux_source_directory(rime/config rime_config_src)
aux_source_directory(rime/dict rime_dict_src)
aux_source_directory(rime/gear rime_gears_src)
aux_source_directory(rime/lever rime_levers_src)
if(rime_plugins_library)
  aux_source_directory(../plugins rime_plugins_src)
endif()

set(rime_core_module_src
  ${rime_api_src}
  ${rime_base_src}
  ${rime_config_src}
  ${rime_proto_objs})
set(rime_dict_module_src
  ${rime_algo_src}
  ${rime_dict_src})

if(BUILD_SHARED_LIBS AND BUILD_SEPARATE_LIBS)
  set(rime_src ${rime_core_module_src})
else()
  set(rime_src
      ${rime_core_module_src}
      ${rime_dict_module_src}
      ${rime_gears_src}
      ${rime_levers_src}
      ${rime_plugins_src}
      ${rime_plugins_objs})
endif()

set(rime_optional_deps "")
if(Gflags_FOUND)
  set(rime_optional_deps ${rime_optional_deps} ${Gflags_LIBRARY})
endif()

set(rime_core_deps
    ${Boost_LIBRARIES}
    CapnProto::capnp
    ${Glog_LIBRARY}
    ${YamlCpp_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT}
    ${rime_optional_deps})
set(rime_dict_deps
    ${LevelDb_LIBRARY}
    ${Marisa_LIBRARY})
set(rime_gears_deps
    ${ICONV_LIBRARIES}
    ${ICU_LIBRARIES}
    ${Opencc_LIBRARY})
set(rime_levers_deps "")

if(MINGW)
  set(rime_core_deps ${rime_core_deps} wsock32 ws2_32)
endif()

if(BUILD_SEPARATE_LIBS)
  set(rime_deps ${rime_core_deps})
else()
  set(rime_deps
    ${rime_core_deps}
    ${rime_dict_deps}
    ${rime_gears_deps}
    ${rime_levers_deps}
    ${rime_plugins_deps})
endif()

if(BUILD_SHARED_LIBS)
  add_library(rime ${rime_src})
  target_link_libraries(rime ${rime_deps})
  set_target_properties(rime PROPERTIES
    DEFINE_SYMBOL "RIME_EXPORTS"
    VERSION ${rime_version}
    SOVERSION ${rime_soversion})
  if(XCODE_VERSION)
    set_target_properties(rime PROPERTIES INSTALL_NAME_DIR "@rpath")
  endif()
  install(TARGETS rime DESTINATION ${LIB_INSTALL_DIR})

  if(BUILD_SEPARATE_LIBS)
    add_library(rime-dict ${rime_dict_module_src})
    target_link_libraries(rime-dict
      ${rime_dict_deps}
      ${rime_library})
    set_target_properties(rime-dict PROPERTIES
      VERSION ${rime_version}
      SOVERSION ${rime_soversion})
    if(XCODE_VERSION)
      set_target_properties(rime-dict PROPERTIES INSTALL_NAME_DIR "@rpath")
    endif()
    install(TARGETS rime-dict DESTINATION ${LIB_INSTALL_DIR})

    add_library(rime-gears ${rime_gears_src})
    target_link_libraries(rime-gears
      ${rime_gears_deps}
      ${rime_library}
      ${rime_dict_library})
    set_target_properties(rime-gears PROPERTIES
      VERSION ${rime_version}
      SOVERSION ${rime_soversion})
    if(XCODE_VERSION)
      set_target_properties(rime-gears PROPERTIES INSTALL_NAME_DIR "@rpath")
    endif()
    install(TARGETS rime-gears DESTINATION ${LIB_INSTALL_DIR})

    add_library(rime-levers ${rime_levers_src})
    target_link_libraries(rime-levers
      ${rime_levers_deps}
      ${rime_library}
      ${rime_dict_library})
    set_target_properties(rime-levers PROPERTIES
      VERSION ${rime_version}
      SOVERSION ${rime_soversion})
    if(XCODE_VERSION)
      set_target_properties(rime-levers PROPERTIES INSTALL_NAME_DIR "@rpath")
    endif()
    install(TARGETS rime-levers DESTINATION ${LIB_INSTALL_DIR})

    if(rime_plugins_library)
      add_library(rime-plugins
        ${rime_plugins_src}
        ${rime_plugins_objs})
      target_link_libraries(rime-plugins
        ${rime_plugins_deps}
        ${rime_library}
        ${rime_dict_library}
        ${rime_gears_library})
      set_target_properties(rime-plugins PROPERTIES
        VERSION ${rime_version}
        SOVERSION ${rime_soversion})
      if(XCODE_VERSION)
        set_target_properties(rime-plugins PROPERTIES INSTALL_NAME_DIR "@rpath")
      endif()
      install(TARGETS rime-plugins DESTINATION ${LIB_INSTALL_DIR})
    endif()
  endif()
else()
  add_library(rime-static STATIC ${rime_src})
  target_link_libraries(rime-static ${rime_deps})
  set_target_properties(rime-static PROPERTIES OUTPUT_NAME "rime" PREFIX "lib")
  install(TARGETS rime-static DESTINATION ${LIB_INSTALL_DIR})
endif()

=== tools/CMakeLists.txt ===
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)

set(rime_console_deps
  ${rime_library}
  ${rime_dict_library}
  ${rime_gears_library}
  ${rime_levers_library}
  ${rime_plugins_library})

set(rime_api_console_src "rime_api_console.cc")
add_executable(rime_api_console ${rime_api_console_src})
target_link_libraries(rime_api_console ${rime_console_deps})

set(CAPNPC_IMPORT_DIRS ${CAPNPC_IMPORT_DIRS} ${RIME_PROTO_SCHEMA_DIR})
capnp_generate_cpp(CAPNP_SRCS CAPNP_HDRS rime_message.capnp)
message(STATUS "compiled capnproto schemata (sources): ${CAPNP_SRCS}")
message(STATUS "compiled capnproto schemata (headers): ${CAPNP_HDRS}")

set(rime_proto_console_src
  "rime_proto_console.cc"
  ${CAPNP_SRCS}
  ${rime_proto_objs})
add_executable(rime_proto_console ${rime_proto_console_src})
target_link_libraries(rime_proto_console ${rime_console_deps})
target_include_directories(rime_proto_console
  PRIVATE
  ${CMAKE_CURRENT_BINARY_DIR}
  ${RIME_PROTO_INCLUDE_DIR})

set(rime_patch_src "rime_patch.cc")
add_executable(rime_patch ${rime_patch_src})
target_link_libraries(rime_patch
  ${rime_library}
  ${rime_levers_library})

# msvc doesn't export all symbols
if(NOT (WIN32 AND BUILD_SHARED_LIBS))

set(rime_console_src "rime_console.cc")
add_executable(rime_console ${rime_console_src})
target_link_libraries(rime_console ${rime_console_deps})

set(rime_dict_manager_src "rime_dict_manager.cc")
add_executable(rime_dict_manager ${rime_dict_manager_src})
target_link_libraries(rime_dict_manager
  ${rime_library}
  ${rime_dict_library}
  ${rime_levers_library})

set(rime_deployer_src "rime_deployer.cc")
add_executable(rime_deployer ${rime_deployer_src})
target_link_libraries(rime_deployer
  ${rime_library}
  ${rime_dict_library}
  ${rime_levers_library})

install(TARGETS rime_deployer DESTINATION ${BIN_INSTALL_DIR})
install(TARGETS rime_dict_manager DESTINATION ${BIN_INSTALL_DIR})

endif()

install(TARGETS rime_patch DESTINATION ${BIN_INSTALL_DIR})

file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/default.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/symbols.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/essay.txt
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/luna_pinyin.dict.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/luna_pinyin.schema.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/cangjie5.dict.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/cangjie5.schema.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})

=== debian/changelog ===
librime (1.6.1+dfsg1-1) unstable; urgency=medium

  * Upload to unstable. (Closes: #971826)

 -- Boyuan Yang <byang@debian.org>  Tue, 12 Jan 2021 11:28:25 -0500

librime (1.6.1+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release 1.6.1.

 -- Boyuan Yang <byang@debian.org>  Sun, 27 Dec 2020 22:47:36 -0500

=== debian/control ===
Source: librime
Section: libs
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Qijiang Fan <fqj1994@gmail.com>,
 Aron Xu <aron@debian.org>,
 YunQiang Su <syq@debian.org>,
 Osamu Aoki <osamu@debian.org>,
 Guo Yixuan (郭溢譞) <culu.gyx@gmail.com>,
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 capnproto,
 cmake (>= 3.0.2),
 debhelper-compat (= 13),
 libboost-dev,
 libboost-filesystem-dev,
 libboost-locale-dev,
 libboost-regex-dev,
 libboost-system-dev,
 libboost-thread-dev,
 libcapnp-dev,
 libgoogle-glog-dev,
 libleveldb-dev,
 libmarisa-dev,
 libopencc-dev (>= 1.1~),
 libyaml-cpp-dev (>= 0.6.3-7~),
 pkg-config,
 x11proto-core-dev,
 zlib1g-dev,
Rules-Requires-Root: no
Standards-Version: 4.5.1
Homepage: https://github.com/rime/librime
Vcs-Git: https://salsa.debian.org/input-method-team/librime.git
Vcs-Browser: https://salsa.debian.org/input-method-team/librime

Package: librime-bin
Architecture: any
Depends:
 librime1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 librime-data (>= 0.38),
Description: Rime Input Method Engine - utilities
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides the executable utilities of RIME.
Section: utils

Package: librime-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 librime1 (<< ${source:Upstream-Version}.0~),
 librime1 (>= ${source:Version}),
 ${misc:Depends},
Provides:
 librime1-dev,
Conflicts:
 librime1-dev,
Replaces:
 librime1-dev,
Description: Rime Input Method Engine, the core library - development files
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides the development files of RIME.

Package: librime1
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Recommends:
 librime-bin,
 librime-data (>= 0.38),
Description: Rime Input Method Engine - core library
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides the core library of RIME.

=== debian/rules ===
#!/usr/bin/make -f

# See dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  =

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -Scmake -- \
	    -DCMAKE_BUILD_TYPE=Release \
	    -DBOOST_USE_CXX11=ON \
	    -DBUILD_TEST=OFF

override_dh_installchangelogs:
	dh_installchangelogs -k CHANGELOG.md

## librime 1.7.3+dfsg3

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,9 @@
 set(CMAKE_USER_MAKE_RULES_OVERRIDE_CXX ${CMAKE_CURRENT_SOURCE_DIR}/cmake/cxx_flag_overrides.cmake)
 
 project(rime)
-cmake_minimum_required(VERSION 3.0.2)
-
-set(rime_version 1.6.1)
+cmake_minimum_required(VERSION 3.10)
+
+set(rime_version 1.7.3)
 set(rime_soversion 1)
 
 add_definitions(-DRIME_VERSION="${rime_version}")
@@ -22,8 +22,11 @@
 option(BOOST_USE_CXX11 "Boost has been built with C++11 support" OFF)
 option(BOOST_USE_SIGNALS2 "Boost use signals2 instead of signals" ON)
 option(ENABLE_ASAN "Enable Address Sanitizer (Unix Only)" OFF)
-
-set(rime_data_dir "/share/rime-data" CACHE STRING "Target directory for Rime data")
+option(INSTALL_PRIVATE_HEADERS "Install private headers (usually needed for externally built Rime plugins)" OFF)
+option(ENABLE_EXTERNAL_PLUGINS "Enable loading of externally built Rime plugins (from directory set by RIME_PLUGINS_DIR variable)" OFF)
+
+set(RIME_DATA_DIR "${CMAKE_INSTALL_FULL_DATADIR}/rime-data" CACHE STRING "Target directory for Rime data")
+set(RIME_PLUGINS_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/rime-plugins" CACHE STRING "Target directory for externally built Rime plugins")
 
 if(WIN32)
   set(ext ".exe")
@@ -61,7 +64,7 @@
 set(BOOST_COMPONENTS filesystem regex system)
 
 if(BOOST_USE_SIGNALS2)
-  add_definitions("-DBOOST_SIGNALS2")
+  set(RIME_BOOST_SIGNALS2 1)
 else()
   set(BOOST_COMPONENTS ${BOOST_COMPONENTS} signals)
 endif()
@@ -89,7 +92,7 @@
     add_definitions(-DGOOGLE_GLOG_DLL_DECL=)
   endif()
 
-  add_definitions(-DRIME_ENABLE_LOGGING)
+  set(RIME_ENABLE_LOGGING 1)
 
 endif()
 
@@ -134,6 +137,11 @@
   message(WARNING "X11/keysym.h not found.")
 endif()
 
+configure_file(
+  "${PROJECT_SOURCE_DIR}/src/rime/build_config.h.in"
+  "${PROJECT_BINARY_DIR}/src/rime/build_config.h")
+
+include_directories(${PROJECT_BINARY_DIR}/src)
 include_directories(${PROJECT_SOURCE_DIR}/src)
 include_directories(${PROJECT_SOURCE_DIR}/thirdparty/include)
 link_directories(${PROJECT_SOURCE_DIR}/thirdparty/lib)
@@ -154,6 +162,7 @@
   set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
 endif()
 
+# keep these variables lest some Rime plugin's cmake file is still using them {
 if(NOT DEFINED LIB_INSTALL_DIR)
     set(LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})
 endif()
@@ -161,6 +170,7 @@
 if(NOT DEFINED BIN_INSTALL_DIR)
     set(BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR})
 endif()
+# }
 
 # uninstall target
 configure_file(
@@ -173,27 +183,42 @@
 if(${CMAKE_SYSTEM_NAME} MATCHES "Linux|FreeBSD|DragonFly|GNU")
   set(prefix "${CMAKE_INSTALL_PREFIX}")
   set(exec_prefix "${CMAKE_INSTALL_PREFIX}")
-  set(bindir "${exec_prefix}/${BIN_INSTALL_DIR}")
-  set(libdir "${exec_prefix}/${LIB_INSTALL_DIR}")
-  set(pkgdatadir "${prefix}${rime_data_dir}")
-  set(includedir "${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
+  set(bindir "${CMAKE_INSTALL_FULL_BINDIR}")
+  set(libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
+  set(pkgdatadir "${RIME_DATA_DIR}")
+  set(pluginsdir "${RIME_PLUGINS_DIR}")
+  set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
   configure_file(
       ${PROJECT_SOURCE_DIR}/rime.pc.in
       ${PROJECT_BINARY_DIR}/rime.pc
       @ONLY)
   install(FILES ${PROJECT_BINARY_DIR}/rime.pc
-    DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
-endif()
-
-install(FILES cmake/RimeConfig.cmake DESTINATION share/cmake/rime)
+    DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig)
+endif()
+
+install(FILES cmake/RimeConfig.cmake
+  DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/cmake/rime)
 
 file(GLOB rime_public_header_files ${PROJECT_SOURCE_DIR}/src/*.h)
-install(FILES ${rime_public_header_files} DESTINATION include)
+install(FILES ${rime_public_header_files}
+  DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR})
+if(INSTALL_PRIVATE_HEADERS)
+  file(GLOB rime_private_header_files
+    ${PROJECT_SOURCE_DIR}/src/rime/*.h
+    ${PROJECT_BINARY_DIR}/src/rime/*.h)
+  install(FILES ${rime_private_header_files}
+    DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/rime)
+  foreach(rime_private_header_files_dir algo config dict gear lever)
+    file(GLOB rime_private_header_files
+      ${PROJECT_SOURCE_DIR}/src/rime/${rime_private_header_files_dir}/*.h)
+    install(FILES ${rime_private_header_files}
+      DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/rime/${rime_private_header_files_dir})
+  endforeach()
+endif()
 
 if(BUILD_DATA)
   file(GLOB rime_preset_data_files ${PROJECT_SOURCE_DIR}/data/preset/*.yaml)
-  install(FILES ${rime_preset_data_files}
-    DESTINATION ${CMAKE_INSTALL_PREFIX}${rime_data_dir})
+  install(FILES ${rime_preset_data_files} DESTINATION ${RIME_DATA_DIR})
 endif()
 
 if(BUILD_SHARED_LIBS)

=== Makefile ===
RIME_ROOT ?= $(CURDIR)

prefix ?= $(DESTDIR)/usr

debug install-debug uninstall-debug test-debug: build ?= debug
build ?= build

.PHONY: all thirdparty xcode clean \
librime librime-static install-librime uninstall-librime \
release debug test install uninstall install-debug uninstall-debug

all: release

thirdparty:
	make -f thirdparty.mk

thirdparty/%:
	make -f thirdparty.mk $(@:thirdparty/%=%)

xcode:
	make -f xcode.mk

xcode/%:
	make -f xcode.mk $(@:xcode/%=%)

clean:
	rm -Rf build debug

librime: release
install-librime: install
uninstall-librime: uninstall

librime-static:
	cmake . -B$(build) \
	-DCMAKE_INSTALL_PREFIX=$(prefix) \
	-DCMAKE_BUILD_TYPE=Release \
	-DBUILD_STATIC=ON \
	-DBUILD_SHARED_LIBS=OFF
	cmake --build $(build)

release:
	cmake . -B$(build) \
	-DCMAKE_INSTALL_PREFIX=$(prefix) \
	-DCMAKE_BUILD_TYPE=Release \
	-DBUILD_MERGED_PLUGINS=OFF \
	-DENABLE_EXTERNAL_PLUGINS=ON
	cmake --build $(build)

merged-plugins:
	cmake . -B$(build) \
	-DCMAKE_INSTALL_PREFIX=$(prefix) \
	-DCMAKE_BUILD_TYPE=Release \
	-DBUILD_MERGED_PLUGINS=ON \
	-DENABLE_EXTERNAL_PLUGINS=OFF
	cmake --build $(build)

debug:
	cmake . -B$(build) \
	-DCMAKE_INSTALL_PREFIX=$(prefix) \
	-DCMAKE_BUILD_TYPE=Debug \
	-DBUILD_MERGED_PLUGINS=OFF \
	-DENABLE_EXTERNAL_PLUGINS=ON
	cmake --build $(build)

install:
	cmake --build $(build) --target install

install-debug:
	cmake --build $(build) --target install

uninstall:
	cmake --build $(build) --target uninstall

uninstall-debug:
	cmake --build $(build) --target uninstall

test: release
	(cd $(build)/test; ./rime_test)

test-debug: debug
	(cd $(build)/test; ./rime_test)

=== plugins/CMakeLists.txt ===
--- 
+++ 
@@ -2,11 +2,25 @@
 set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)
 
 # work around CMake build issues on macOS
-aux_source_directory(. rime_plugins_src)
+set(rime_plugin_boilerplate_src "plugin.cc")
+
+set(plugins_module_src "plugins_module.cc")
 
 unset(plugins_objs)
 unset(plugins_deps)
 unset(plugins_modules)
+
+if(ENABLE_EXTERNAL_PLUGINS)
+  add_library(rime-plugins-objs OBJECT ${plugins_module_src})
+  if(BUILD_SHARED_LIBS)
+    set_target_properties(rime-plugins-objs
+      PROPERTIES
+      POSITION_INDEPENDENT_CODE ON)
+  endif()
+
+  set(plugins_objs ${plugins_objs} $<TARGET_OBJECTS:rime-plugins-objs>)
+  set(plugins_modules ${plugins_modules} "plugins")
+endif()
 
 if(DEFINED ENV{RIME_PLUGINS})
   set(plugins $ENV{RIME_PLUGINS})
@@ -38,12 +52,12 @@
     set(plugins_modules ${plugins_modules} ${plugin_modules})
   else()
     message(STATUS "Plugin ${plugin_name} provides modules: ${plugin_modules}")
-    add_library(${plugin_name} ${rime_plugins_src} ${plugin_objs})
+    add_library(${plugin_name} ${rime_plugin_boilerplate_src} ${plugin_objs})
     target_link_libraries(${plugin_name} ${plugin_deps})
     if(XCODE_VERSION)
       set_target_properties(${plugin_name} PROPERTIES INSTALL_NAME_DIR "@rpath")
     endif(XCODE_VERSION)
-    install(TARGETS ${plugin_name} DESTINATION ${LIB_INSTALL_DIR})
+    install(TARGETS ${plugin_name} DESTINATION ${RIME_PLUGINS_DIR})
   endif()
 endforeach(plugin)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -35,6 +35,9 @@
 set(rime_optional_deps "")
 if(Gflags_FOUND)
   set(rime_optional_deps ${rime_optional_deps} ${Gflags_LIBRARY})
+endif()
+if(ENABLE_EXTERNAL_PLUGINS)
+  set(rime_optional_deps ${rime_optional_deps} dl)
 endif()
 
 set(rime_core_deps
@@ -78,7 +81,7 @@
   if(XCODE_VERSION)
     set_target_properties(rime PROPERTIES INSTALL_NAME_DIR "@rpath")
   endif()
-  install(TARGETS rime DESTINATION ${LIB_INSTALL_DIR})
+  install(TARGETS rime DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})
 
   if(BUILD_SEPARATE_LIBS)
     add_library(rime-dict ${rime_dict_module_src})
@@ -91,7 +94,7 @@
     if(XCODE_VERSION)
       set_target_properties(rime-dict PROPERTIES INSTALL_NAME_DIR "@rpath")
     endif()
-    install(TARGETS rime-dict DESTINATION ${LIB_INSTALL_DIR})
+    install(TARGETS rime-dict DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})
 
     add_library(rime-gears ${rime_gears_src})
     target_link_libraries(rime-gears
@@ -104,7 +107,7 @@
     if(XCODE_VERSION)
       set_target_properties(rime-gears PROPERTIES INSTALL_NAME_DIR "@rpath")
     endif()
-    install(TARGETS rime-gears DESTINATION ${LIB_INSTALL_DIR})
+    install(TARGETS rime-gears DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})
 
     add_library(rime-levers ${rime_levers_src})
     target_link_libraries(rime-levers
@@ -117,7 +120,7 @@
     if(XCODE_VERSION)
       set_target_properties(rime-levers PROPERTIES INSTALL_NAME_DIR "@rpath")
     endif()
-    install(TARGETS rime-levers DESTINATION ${LIB_INSTALL_DIR})
+    install(TARGETS rime-levers DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})
 
     if(rime_plugins_library)
       add_library(rime-plugins
@@ -134,12 +137,12 @@
       if(XCODE_VERSION)
         set_target_properties(rime-plugins PROPERTIES INSTALL_NAME_DIR "@rpath")
       endif()
-      install(TARGETS rime-plugins DESTINATION ${LIB_INSTALL_DIR})
+      install(TARGETS rime-plugins DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})
     endif()
   endif()
 else()
   add_library(rime-static STATIC ${rime_src})
   target_link_libraries(rime-static ${rime_deps})
   set_target_properties(rime-static PROPERTIES OUTPUT_NAME "rime" PREFIX "lib")
-  install(TARGETS rime-static DESTINATION ${LIB_INSTALL_DIR})
+  install(TARGETS rime-static DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})
 endif()

=== thirdparty/src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# libmarisa

# Official repo: https://github.com/s-yata/marisa-trie
# CMake script borrowed from https://github.com/Karry/osmscout-sailfish/blob/master/CMakeLists.txt

# libmarisa don't have cmake based build, but it is relatively small,
# so we define library target here

if(UNIX)
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Weffc++ -Wextra -Wconversion")
endif()

set(MARISA_ROOT ${CMAKE_HOME_DIRECTORY}/marisa-trie)

set(MARISA_INCLUDE_DIRS
    ${MARISA_ROOT}/lib
    ${MARISA_ROOT}/include)

set(MARISA_SRC
    ${MARISA_ROOT}/lib/marisa/grimoire/io/reader.cc
    ${MARISA_ROOT}/lib/marisa/grimoire/io/mapper.cc
    ${MARISA_ROOT}/lib/marisa/grimoire/io/writer.cc
    ${MARISA_ROOT}/lib/marisa/grimoire/trie/tail.cc
    ${MARISA_ROOT}/lib/marisa/grimoire/trie/louds-trie.cc
    ${MARISA_ROOT}/lib/marisa/grimoire/vector/bit-vector.cc
    ${MARISA_ROOT}/lib/marisa/trie.cc
    ${MARISA_ROOT}/lib/marisa/agent.cc
    ${MARISA_ROOT}/lib/marisa/keyset.cc
)

include_directories(
  ${MARISA_INCLUDE_DIRS}
)

add_library(marisa
    ${MARISA_SRC}
)

install(TARGETS marisa
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib)

set(include_headers ${MARISA_ROOT}/include/marisa.h)
file(GLOB libmarisa_include_headers ${MARISA_ROOT}/include/marisa/*.h)
install(FILES ${include_headers} DESTINATION include)
install(FILES ${libmarisa_include_headers} DESTINATION include/marisa)

=== debian/changelog ===
librime (1.7.3+dfsg3-2build2) jammy; urgency=medium

  * No-change rebuild against libcapnp-0.8.0

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 07 Mar 2022 21:48:39 +0000

librime (1.7.3+dfsg3-2build1) jammy; urgency=medium

  * No-change rebuild against libboost-regex1.74.0-icu70.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 10 Feb 2022 16:02:37 +0100

librime (1.7.3+dfsg3-2) unstable; urgency=medium

  * Source-only upload.
  * debian/upstream/metadata: Add metadata file.
  * debian/control: Drop Multi-Arch: same field from package librime-dev.
    /usr/include/rime/build_config.h contains arch-dependent information.

 -- Boyuan Yang <byang@debian.org>  Mon, 17 Jan 2022 14:29:12 -0500

librime (1.7.3+dfsg3-1) unstable; urgency=medium

  * Include source code for more extensions:
    + librime-charcode
    + librime-octagram
  * Add new binary packages accordingly:
    + librime-plugin-charcode
    + librime-plugin-octagram
  * debian/copyright: Updated accordingly.
  * debian/control: Let librime1 recommend installation of plugins.

 -- Boyuan Yang <byang@debian.org>  Sun, 16 Jan 2022 16:45:14 -0500

librime (1.7.3+dfsg2-1) unstable; urgency=medium

  * Include source code for librime-lua extension.
  * debian/control: Add new binary package librime-plugin-lua.
  * debian/rules: Update plugin logic accordingly.
  * debian/librime-plugin-lua.lintian-overrides:
    + Also override lintian shared-library-is-executable.

 -- Boyuan Yang <byang@debian.org>  Sun, 16 Jan 2022 16:12:48 -0500

librime (1.7.3+dfsg1-2) unstable; urgency=medium

  * librime-bin: Install custom helper script debian-rime-processor
    into /usr/bin/ to help with future build of RIME schemas.

 -- Boyuan Yang <byang@debian.org>  Fri, 17 Dec 2021 21:57:06 -0500

librime (1.7.3+dfsg1-1) unstable; urgency=medium

  * New upstream version 1.7.3+dfsg1.
  * debian/librime1.shlibs: Limit to latest build.
  * Bump Standards-Version to 4.6.0.
  * debian/control: Require cmake 3.10+.
  * debian/rules: Enable external plugin loading.

 -- Boyuan Yang <byang@debian.org>  Sat, 02 Oct 2021 23:43:21 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: librime
 Section: libs
 Priority: optional
-Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
 Uploaders:
  Qijiang Fan <fqj1994@gmail.com>,
  Aron Xu <aron@debian.org>,
@@ -11,7 +12,8 @@
  Boyuan Yang <byang@debian.org>,
 Build-Depends:
  capnproto,
- cmake (>= 3.0.2),
+ cmake (>= 3.10),
+ darts,
  debhelper-compat (= 13),
  libboost-dev,
  libboost-filesystem-dev,
@@ -22,14 +24,16 @@
  libcapnp-dev,
  libgoogle-glog-dev,
  libleveldb-dev,
+ liblua5.4-dev,
  libmarisa-dev,
  libopencc-dev (>= 1.1~),
+ libxcb-keysyms1-dev,
  libyaml-cpp-dev (>= 0.6.3-7~),
  pkg-config,
  x11proto-core-dev,
  zlib1g-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/rime/librime
 Vcs-Git: https://salsa.debian.org/input-method-team/librime.git
 Vcs-Browser: https://salsa.debian.org/input-method-team/librime
@@ -57,7 +61,6 @@
 
 Package: librime-dev
 Architecture: any
-Multi-Arch: same
 Section: libdevel
 Depends:
  librime1 (<< ${source:Upstream-Version}.0~),
@@ -81,6 +84,70 @@
  .
  This package provides the development files of RIME.
 
+Package: librime-plugin-charcode
+Architecture: any
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Multi-Arch: same
+Homepage: https://github.com/rime/librime-charcode
+Description: Rime Input Method Engine - charcode plugin
+ RIME is the acronym of Rime Input Method Engine.
+ .
+ RIME is a lightweight, extensible input method engine supporting various input
+ schematas including glyph-based input methods, romanization-based input methods
+ as well as those for Chinese dialects. It has the ability to compose phrases
+ and sentences intelligently and provide very accurate traditional Chinese
+ output. RIME's cross-platform core library is written in C++, and can work
+ consistently on different platforms with OS-specific wrappers.
+ .
+ This package provides charcode plugin for RIME. It can be used for codepoint
+ translation and charset filtering.
+
+Package: librime-plugin-lua
+Architecture: any
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Multi-Arch: same
+Homepage: https://github.com/hchunhui/librime-lua
+Description: Rime Input Method Engine - Lua extension plugin
+ RIME is the acronym of Rime Input Method Engine.
+ .
+ RIME is a lightweight, extensible input method engine supporting various input
+ schematas including glyph-based input methods, romanization-based input methods
+ as well as those for Chinese dialects. It has the ability to compose phrases
+ and sentences intelligently and provide very accurate traditional Chinese
+ output. RIME's cross-platform core library is written in C++, and can work
+ consistently on different platforms with OS-specific wrappers.
+ .
+ This package provides lua extension plugin for RIME with the following
+ features:
+ .
+   * Supports extending RIME processors, segmentors, translators and filters
+   * Provides high-level programming model for translators and filters
+   * Loaded dynamically as a librime plugin
+
+Package: librime-plugin-octagram
+Architecture: any
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Multi-Arch: same
+Homepage: https://github.com/lotem/librime-octagram
+Description: Rime Input Method Engine - octagram plugin
+ RIME is the acronym of Rime Input Method Engine.
+ .
+ RIME is a lightweight, extensible input method engine supporting various input
+ schematas including glyph-based input methods, romanization-based input methods
+ as well as those for Chinese dialects. It has the ability to compose phrases
+ and sentences intelligently and provide very accurate traditional Chinese
+ output. RIME's cross-platform core library is written in C++, and can work
+ consistently on different platforms with OS-specific wrappers.
+ .
+ This package provides octagram plugin for RIME. It provides extra functionality
+ in grammar checking.
+
 Package: librime1
 Architecture: any
 Depends:
@@ -90,6 +157,9 @@
 Recommends:
  librime-bin,
  librime-data (>= 0.38),
+ librime-plugin-charcode,
+ librime-plugin-lua,
+ librime-plugin-octagram,
 Description: Rime Input Method Engine - core library
  RIME is the acronym of Rime Input Method Engine.
  .

=== debian/rules ===
--- 
+++ 
@@ -8,10 +8,21 @@
 	dh $@ --buildsystem=cmake
 
 override_dh_auto_configure:
+	cp -r ./librime-lua ./plugins/lua
+	cp -r ./librime-octagram ./plugins/octagram
+	cp -r ./librime-charcode ./plugins/charcode
 	dh_auto_configure -Scmake -- \
 	    -DCMAKE_BUILD_TYPE=Release \
+	    -DINSTALL_PRIVATE_HEADERS=ON \
+	    -DENABLE_EXTERNAL_PLUGINS=ON \
 	    -DBOOST_USE_CXX11=ON \
-	    -DBUILD_TEST=OFF
+	    -DBUILD_TEST=OFF \
+	    -DBUILD_MERGED_PLUGINS=Off \
+	    -DENABLE_EXTERNAL_PLUGINS=On
 
 override_dh_installchangelogs:
 	dh_installchangelogs -k CHANGELOG.md
+
+execute_after_dh_fixperms:
+	# https://github.com/rime/librime/issues/520
+	chmod 755 $(CURDIR)/debian/*/usr/lib/*/rime-plugins/*.so

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d?$//,compression=xz,repack,repacksuffix=+dfsg3" \
 https://github.com/rime/librime/tags .*/(\d[\d\.]+)\.tar\.gz debian uupdate
opts="component=librime-lua,mode=git,pgpmode=none" \
 https://github.com/hchunhui/librime-lua HEAD ignore
opts="component=librime-charcode,mode=git,pgpmode=none" \
 https://github.com/rime/librime-charcode HEAD ignore
opts="component=librime-octagram,mode=git,pgpmode=none" \
 https://github.com/lotem/librime-octagram HEAD ignore

## librime 1.7.3+dfsg4

=== debian/changelog ===
librime (1.7.3+dfsg4-2) unstable; urgency=medium

  * Rebuild against opencc 1.1.4.
  * debian/control: Bump Standards-Version to 4.6.1.

 -- Boyuan Yang <byang@debian.org>  Sat, 04 Jun 2022 20:30:44 -0400

librime (1.7.3+dfsg4-1) unstable; urgency=medium

  * debian/rules: Use individual binary package version strings for
    plugin packages via dh_gencontrol.
  * Update plugins to latest git snapshot:
    + charcode: 20220204
    + lua: 20220206
    + octogram: 20210816

 -- Boyuan Yang <byang@debian.org>  Sun, 13 Mar 2022 11:27:41 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: librime
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
+Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
 Uploaders:
  Qijiang Fan <fqj1994@gmail.com>,
  Aron Xu <aron@debian.org>,
@@ -33,7 +32,7 @@
  x11proto-core-dev,
  zlib1g-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/rime/librime
 Vcs-Git: https://salsa.debian.org/input-method-team/librime.git
 Vcs-Browser: https://salsa.debian.org/input-method-team/librime

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,15 @@
 # See dpkg-buildflags(1)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND  =
+
+include /usr/share/dpkg/default.mk
+
+# For individual package versions
+REV_CHARCODE = 20220204
+REV_LUA = 20220206
+REV_OCTAGRAM = 20210816
+
+_DEB_VERSION_REVISION = $(shell echo $(DEB_VERSION) | sed -e 's/^.*-//g')
 
 %:
 	dh $@ --buildsystem=cmake
@@ -26,3 +35,13 @@
 execute_after_dh_fixperms:
 	# https://github.com/rime/librime/issues/520
 	chmod 755 $(CURDIR)/debian/*/usr/lib/*/rime-plugins/*.so
+
+# Individual version number for librime-plugin-*
+override_dh_gencontrol:
+	dh_gencontrol -plibrime-plugin-charcode -- \
+	        -v$(DEB_VERSION_EPOCH_UPSTREAM)~git$(REV_CHARCODE)-$(_DEB_VERSION_REVISION)
+	dh_gencontrol -plibrime-plugin-lua -- \
+	        -v$(DEB_VERSION_EPOCH_UPSTREAM)~git$(REV_LUA)-$(_DEB_VERSION_REVISION)
+	dh_gencontrol -plibrime-plugin-octagram -- \
+	        -v$(DEB_VERSION_EPOCH_UPSTREAM)~git$(REV_OCTAGRAM)-$(_DEB_VERSION_REVISION)
+	dh_gencontrol --remaining-packages

=== debian/watch ===
--- 
+++ 
@@ -1,5 +1,5 @@
 version=4
-opts="dversionmangle=s/\+dfsg\d?$//,compression=xz,repack,repacksuffix=+dfsg3" \
+opts="dversionmangle=s/\+dfsg\d?$//,compression=xz,repack,repacksuffix=+dfsg4" \
  https://github.com/rime/librime/tags .*/(\d[\d\.]+)\.tar\.gz debian uupdate
 opts="component=librime-lua,mode=git,pgpmode=none" \
  https://github.com/hchunhui/librime-lua HEAD ignore
